/** 
 * Sahayogi, Mobile App of West Bengal State Electricity Distribution Company Ltd.
 * for enhance value added services to consumers.

 *Author : Suvendu Dalal, DE(E), IT&C Cell, WBSEDCL <dalal.suvendu@gmail.com>
 *Created on : 2015-11-05
 *
 * Contributor(s):
 *		Soumitro Biswas, SE(E), IT&C Cell,
 *		Joydeep Sarkar, DE(E), IT&C Cell,
 *		Soumen Mandal, AE(IT&C), IT&C Cell,
 *		Krishnendu Dutta, AE(IT&C) IT&C Cell
 */


var serverURL = "https://mapp.wbsedcl.in/sahayogi/mobapp-102-20170717/";			//Production server address
var ajaxTimeout = 300000;								//timeout time in  milliseconds
var intervalId = ''										//javascript interval for OTP count down timer
var nxtRefresh = 0;										//last access time stamp
var devData = {};										//device data
var aplData = {};										//application data obj
var conData = "";										//consumer details
var pgNav = "";											// page navigation
var ti = $.now();										// for debug
var writeEnable = 'Y';									//write enable
var local = new Object();								// Local settings variable
local.Lng = 'LngEng';									// Default Language English

var pathAsset = '';										//path of Application
var pathAppData = '';									//path of Application private data
var pathDwnld = "file:///storage/emulated/0/Download/";	//path of download files for Android

//dom load complitly
$(document).ready(fnAppInitilize);

//cordova load complitly
function fnAppInitilize(){
	$(document).bind("deviceready", fnAppOn );
	/*$(document).bind("resume", function(){				//background process resume
		devData = {};
		ti = $.now();
		fnAppOn();
	});*/
}

//app on virtual platform validation
function fnAppOn(){
	pathAsset = cordova.file.applicationDirectory;		//path of Application for Android
	pathAppData = cordova.file.dataDirectory;			//path of Application private data for Android
	
	//alert (device.uuid+'----'+device.serial+'----'+device.isVirtual);
	devData.devUUID = device.uuid;
	devData.osPlatform = device.platform;
	if (device.isVirtual){
		navigator.notification.alert(
			"Virtual device not suppoted.", 
			function(buttonIndex){
				navigator.app.exitApp();
			}, 
			"Error"
		);
	}else{
		if( device.platform == 'Android' || device.platform == 'iOS'){
			fnAppVer();
		}else{
			navigator.notification.alert(
				"Device Platform not suppoted.", 
				function(buttonIndex){
					navigator.app.exitApp();
				}, 
				"Error"
			);
		}
	}
}

//app version
function fnAppVer() {
	cordova.getAppVersion.getVersionNumber(function (d) {
		//alert(d);
		devData["appVr"] = d;
		fnAppId();
	});
}

//app id in stor
function fnAppId() {
	cordova.getAppVersion.getVersionCode(function (d) {
		//alert(d);
		devData["appId"] = d;
		fnAppPkNm();
	});
}

//Returns the package name of the app - the reversed domain name app identifier like com.example.myawesomeapp 
function fnAppPkNm() {
	cordova.getAppVersion.getPackageName(function (d) {
		//alert(d);
		devData["appPkNm"] = d;
		fnAppMac();
	});
}

//device MAC Address
function fnAppMac() {
	window.MacAddress.getMacAddress(function(d) {
		//alert(d);
		devData["devMAC"] = d;
		fnNetStat();
	});
}

// network status notification
function fnNetStat() {
	if (navigator.connection.type == 'none'){
		navigator.notification.alert(
			"No network or data connection.", 
			function(buttonIndex){
				ConfirmExit(1);
			}, 
			"Error"
		); 
		return false;
	}
	fnMain();
}

// application exit notification
function ConfirmExit(stat){
	if(stat == "1"){
	    navigator.app.exitApp();
	}else{
	    return;
	};
};

// backbutton press notification
function fnBkButon() {
	$(document).bind("backbutton", function(e){
		if ( !$('#appAds').length && $('#appBody').length ) {
			readFromFile(pathAsset,"www/home.html","body");
		}else{
			navigator.notification.confirm(
				"Do you really want to close this app?", 
				function(buttonIndex){
					ConfirmExit(buttonIndex);
				}, 
				"Confirmation",
				"Yes,No"
			);
		}
	});
}

//ajax load server page
function fnServerURL(domRef,fileName){
//ti = $.now();
	//attach busy animation
	$("#appBusy").addClass( "appBusy" );
	writeEnable = 'Y';
	
	$.ajax({
		type: "POST"
		,timeout: ajaxTimeout
		,url: serverURL
		,data:{devData:devData}
		,success: function(data){
		  	//alert(data);
		  	$(domRef).html(data);
		  	$("#PgNavigation").html( pgNav + ' > Cons '  );
		  	if ( fileName.length > 0 && writeEnable == 'Y' ){
		  		writeToFile(fileName,data.replace("devData['devKy']", "tmp"));
		  	}
			if( $("#appBusy").hasClass( "appBusy" ) ){
				$("#appBusy").removeClass( "appBusy" );	//removed busy animation Server not found
			}
		  	//alert($.now() - ti);
	  	}
		,error: function(request, status, err){
			navigator.notification.alert(
				"The server could be temporarily unavailable or too busy. Try again later.", 
				function(buttonIndex){
					if( $("#appBusy").hasClass( "appBusy" ) ){
						$("#appBusy").removeClass( "appBusy" );	//removed busy animation Server not found
					}
				}, 
				"Error "+err
			); 
			return false;
		}	  	
	});
}

//file load either locally or from server based on last modified date time
function fnFileLoad(fileName,domRef,pdId){
	$(domRef).css('display','none');
	window.resolveLocalFileSystemURL(pathAppData+fileName, function (fileEntry) { 
		fileEntry.file(function(file) {
			devData["appPgId"] = pdId;
			$.ajax({
				type: "POST"
				,url: pathAppData+fileName
				,success: function(data){
				  	$(domRef).html(data);
				  	//alert(nxtRefresh);
					if ( file.lastModifiedDate <= $.now() && file.lastModifiedDate + nxtRefresh <= $.now() && 0 <= nxtRefresh ){
						//alert('File over write.');
						fnServerURL(domRef,fileName);
						$(domRef).css('display','block');
					}else{
		  				$("#PgNavigation").html( pgNav + ' > Cons '  );
						$(domRef).css('display','block');
					}
			  	}  	
			});
		});
	},function(){
		//alert('New file create.');
		devData["appPgId"] = pdId;
		fnServerURL(domRef,fileName);
		$(domRef).css('display','block');
	});
}

//cordova file read from local file system
function readFromFile(dir,fileName,divNm){
	window.resolveLocalFileSystemURL(dir+fileName, function (fileEntry) { 
		fileEntry.file(function (file) {
			var reader = new FileReader();
		    reader.onloadend = function (e) {
		        var data = this.result;
		        $(divNm).html(data);
		    };
		    reader.readAsText(file);
		},errorHandler.bind(null, fileName));
	},errorHandler.bind(null, fileName));
}

//cordova file write to local file system
function writeToFile(fileName,data) {
	window.resolveLocalFileSystemURL(pathAppData, function (directoryEntry) {
		directoryEntry.getFile(fileName, { create: true }, function (fileEntry) {
			fileEntry.createWriter(function (fileWriter) {
		        fileWriter.onwriteend = function (e) {
		            // for real-world usage, you might consider passing a success callback
		            console.log('Write of file "' + fileName + '"" completed.');
		        };

		        fileWriter.onerror = function (e) {
		            // you could hook this up with our global error handler, or pass in an error callback
		            console.log('Write failed: ' + e.toString());
		            alert(e.toString());
		        };	
		        fileWriter.write(data);	
			},errorHandler.bind(null, fileName));
		},errorHandler.bind(null, fileName));
	},errorHandler.bind(null, fileName));
}

//cordova file write to local file system external directory
function writeToFileExt(dir,fileName,data,ftyp) {
	window.resolveLocalFileSystemURL(dir, function (directoryEntry) {
		directoryEntry.getFile(fileName, { create: true }, function (fileEntry) {
			fileEntry.createWriter(function (fileWriter) {
		        fileWriter.onwriteend = function (e) {
		            // for real-world usage, you might consider passing a success callback
		            console.log('Write of file "' + fileName + '"" completed.');
		        };

		        fileWriter.onerror = function (e) {
		            // you could hook this up with our global error handler, or pass in an error callback
		            console.log('Write failed: ' + e.toString());
		            alert(e.toString());
		        };
		        var blob = new Blob([data],{type: ftyp});	
		        fileWriter.write(blob);	
			},errorHandler.bind(null, fileName));
		},errorHandler.bind(null, fileName));
	},errorHandler.bind(null, fileName));
}

//file read/write error handler
var errorHandler = function (fileName, e) {  
    var msg = '';

    switch (e.code) {
        case FileError.QUOTA_EXCEEDED_ERR:
            msg = 'Storage quota exceeded';
            break;
        case FileError.NOT_FOUND_ERR:
            msg = 'File not found';
            break;
        case FileError.SECURITY_ERR:
            msg = 'Security error';
            break;
        case FileError.INVALID_MODIFICATION_ERR:
            msg = 'Invalid modification';
            break;
        case FileError.INVALID_STATE_ERR:
            msg = 'Invalid state';
            break;
        default:
            msg = 'Unknown error';
            break;
    };
	navigator.notification.alert(
		"Error: "+  msg, 
		null, 
		fileName
	);
}

// local settings file r/w
function localSett(){
	window.resolveLocalFileSystemURL(pathAppData+'local-sett.ini', function (fileEntry) { 
		fileEntry.file(function(file) {
			var reader = new FileReader();
		    reader.onloadend = function (e) {
		        var data = this.result;
				local = JSON.parse(data);
		    };
		    reader.readAsText(file);
		});
	},function(){
		writeToFile('local-sett.ini','{"Lng":"LngEng"}');
	});
}

function fnCustomDialog(p){
	$("#appDialog").css("display", "block");
	$("#appDialogTitle").html(p.title);
	$("#appDialogBody").html(p.body);
	$("#appDialogBut1").html(p.but1);
	if (p.but2.length>0){
		$("#appDialogBut2").css("display", "inline");
		$("#appDialogBut2").html(p.but2);
	}
}

	//fnCustomDialog({"title":"aa","body":"bb","but1":"Submit"});

//app functional code
function fnMain(){
	//alert ('MAC : '+devData.devMAC+" Version : "+devData.appVr+" ID : "+devData.appId+" PkNm : "+devData.appPkNm);
	fnBkButon();							//back button press event
	localSett();							//local settings
	devData["Lng"] = local.Lng;
	fnServerURL("body","");					//request post to server
	$("body").addClass("waterMark");		//attache watermark on body
}

